# print_string_arm.s

# Syscalls
.equ SYSCALL_EXIT,     1
.equ SYSCALL_WRITE,    4

# Other definitions
.equ STDOUT,	       1

        .globl _start
_start:
	ldr	r1,=hello
	bl	print_string		@ Print Hello World
	ldr	r1,=mystery
	bl	print_string		@
	ldr	r1,=goodbye
	bl	print_string		@ Print Goodbye
	

        #================================
        # Exit
        #================================
exit:
	mov	r0,#5
        mov     r7,#SYSCALL_EXIT	@ put exit syscall number (1) in eax
	swi	0x0			@ and exit


	#====================
	# print string
	#====================
	# Null-terminated string to print pointed to by r1
	# r0,r1,r2,r3 is trashed by this routine

print_string:
	mov	r2,#0			@ Clear Count

count_loop:
	add	r2,r2,#1		@ increment count
	ldrb	r3,[r1,r2]		@ load byte from address r1+r2
	cmp	r3,#0			@ Compare against 0
	bne	count_loop		@ if not 0, loop

	mov	r0,#STDOUT		@ Print to stdout
	mov	r7,#SYSCALL_WRITE	@ Load syscall number
	swi	0x0			@ System call

	mov	pc,lr			@ Return to address stored in
					@ Link register

					@ What happens if nested calls?
	
	
.data
hello:		.string "Hello World!\n"   @ includes null at end
mystery:	.byte 63,0x3f,63,10,0      @ mystery string
goodbye:	.string "Goodbye!\n"	   @ includes null at end
